#
#   5B - Light bulb
#

from part import Part
from albow.image_array import get_image_array

class LightBulb(Part):
	#  on   boolean
	
	images = get_image_array("parts/lightbulb.png", 2, border = 2)
	
	terminal_points = [(-20, 5), (20, 5)]
	
	on = False
	
	def reset(self):
		self.on = False
	
	def draw(self, surf, t):
		r = self.get_translated_global_rect(t)
		image = self.images[self.on]
		surf.blit(image, r)
	
	def begin_frame(self):
		self.on = self.power_across(0, 1)

	def get_oriented_rect(self):
		return self.images[0].get_rect()
