#
#   5B - Relay
#

from albow.image_array import get_image_array
from image import RotatableImage
from part import Part

IDLE = 'idle'
OPERATING = 'operating'
RELEASING = 'releasing'

class Relay(Part):

	terminal_points = [(-20, 25), (-10, 25), (0, 25), (10, 25), (20, 25)]
	base_images = get_image_array("parts/relay.png", 2, border = 2)
	images = [RotatableImage(base_images[i]) for i in xrange(2)]
	is_rotatable = True
	
	state = IDLE
	operated = False

	def reset(self):
		self.state = IDLE
		self.operated = False
		
#	def draw(self, surf, t):
#		self.images[self.operated].draw(surf, t * self.position, self.orientation)
	
	def get_rotatable_image(self):
		return self.images[self.operated]

	def begin_frame(self):
		state = self.state
		if state == OPERATING:
			self.operated = True
			self.state = IDLE
		elif state == RELEASING:
			self.operated = False
			self.state = IDLE
		else:
			if self.power_across(0, 1):
				if not self.operated:
					self.state = OPERATING
			else:
				if self.operated:
					self.state = RELEASING

	def node_changed(self, n):
		if self.operated:
			m = 4
		else:
			m = 2
		if n == 3 or n == m:
			self.propagate(m, n)
