#
#   5B - Third Party Telephone
#

from random import randint, choice
from settings import milliseconds_to_frames
from telephone import Telephone, IDLE

WAIT_CALL = 'wait_call'
WAIT_DIAL = 'wait_dial'
WAIT_HANGUP = 'wait_hangup'

interdigit_delay = 250 # ms

class ThirdPartyTelephone(Telephone):

	color_no = 2

	def finished_dialling(self):
		print "Grey phone: Finished dialling" ###
		if self.digits:
			#self.dial_next_digit()
			self.timeout = milliseconds_to_frames(interdigit_delay)
			self.state = WAIT_DIAL
			print "Grey phone: WAIT_DIAL", self.timeout ###
		else:
			self.timeout = self.random_hangup_delay()
			self.state = WAIT_HANGUP
			print "Grey phone: WAIT_HANGUP", self.timeout ###
	
	def dial_next_digit(self):
		digit = self.digits.pop()
		self.begin_dialling(digit)
	
	def set_up_for_next_call(self):
		self.timeout = self.random_call_delay()
		self.digits = self.random_digit_sequence()
		self.state = WAIT_CALL
		print "Grey phone: WAIT_CALL", self.timeout, self.digits ###

	def begin_frame(self):
		state = self.state
		if state == IDLE:
			self.set_up_for_next_call()
		elif state == WAIT_CALL:
			self.timeout -= 1
			if self.timeout <= 0:
				self.set_off_hook(True)
				self.timeout = self.random_dialling_delay()
				self.state = WAIT_DIAL
				print "Grey phone: WAIT_DIAL", self.timeout ###
		elif state == WAIT_DIAL:
			self.timeout -= 1
			if self.timeout <= 0:
				self.dial_next_digit()
		elif state == WAIT_HANGUP:
			self.timeout -= 1
			if self.timeout <= 0:
				self.set_off_hook(False)
				self.set_up_for_next_call()
		else:
			Telephone.begin_frame(self)

	def random_call_delay(self):
		return milliseconds_to_frames(randint(1000, 10000))
	
	def random_dialling_delay(self):
		return milliseconds_to_frames(randint(500, 1000))
	
	def random_hangup_delay(self):
		return milliseconds_to_frames(randint(2000, 5000))

	def random_digit_sequence(self):
		n = randint(1, 3)
		return [randint(0, 9) for i in xrange(n)]
